/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "SoundBufferManager.hpp"

SoundBufferManager *SoundBufferManager::singletonObject = 0;

SoundBufferManager::SoundBufferManager()
{
    
}

SoundBufferManager *SoundBufferManager::getInstance()
{
    if (!singletonObject)
        singletonObject = new SoundBufferManager();
    
    return singletonObject;
}

sf::SoundBuffer *SoundBufferManager::getSoundBuffer(const std::string &soundPath)
{
    if (!isSoundBufferLoaded(soundPath))
        loadSoundBuffer(soundPath);
    
    return &m_soundBuffersList[soundPath];
}

void SoundBufferManager::loadSoundBuffer(const std::string &soundPath)
{
    sf::SoundBuffer loadedSoundBuffer;
    loadedSoundBuffer.LoadFromFile(soundPath);
    
    m_soundBuffersList[soundPath] = loadedSoundBuffer;
}

bool SoundBufferManager::isSoundBufferLoaded(const std::string &soundPath)
{
    std::map<std::string, sf::SoundBuffer>::iterator it;
    it = m_soundBuffersList.find(soundPath);
    
    if (it != m_soundBuffersList.end())
        return true;
    
    return false;
}